#!/usr/local/bin/perl

$ENV{"PATH"} .= ":/usr/bin:/usr/sbin:/usr/local/bin:/usr/local/dba/tools:/opt/dbamon/bin";
# !+-------------------------------------------------------------------------
#    Name:  dbamon_inhibit.pl
# !*-------------------------------------------------------------------------

chop($P = `basename $0`);
$| = 1;

use DBI;
use Time::Local;
require "cgi_handlers.pl";

# Trap an interrupt signal and clean up
$SIG{'INT'} = 'IntHandler';

#---- Read WWW_Check:
chop($font = `grep 'WWW_Font:' /opt/dbamon/adm/dbamonrc | grep -v '^#' | awk '{ print \$2 }'`);
if ($font =~ /%/)
{
  $font =~ s/%/ /g;
  $font = "'$font'";
}
$font = "arial" if ! $font;
$fs = "<font size=2 face=$font>"; 

push(@INC,"/opt/dbamon/lib");
require "subs.pl";
require "subsDB.pl";
require "subsWWW.pl";

#&header("Inhibit TEST");
#&setEnv;

#------------------------------------------------------------------------------
#
# Subroutines
#
#------------------------------------------------------------------------------

#------------------------------------------------------------------------------
sub msgOld
#------------------------------------------------------------------------------
{
  my $msg = $_[0];
  chop($date = `date +%Y/%m/%d-%H:%M:%S`);
  ##print "</center><br><font size=2>$date ${P} | <b>$msgmsg</b></font><center>\n";
  print "<br><font size=2 face=$font>$date ${P} | <b>$msg</b></font>\n";
}

#------------------------------------------------------------------------------
sub timeToText
#------------------------------------------------------------------------------
{
  $zz_ts = $_[0];
  ($sec,$min,$hour,$mday,$mon,$year) = localtime($zz_ts);
  $year += 1900;
  $mon += 1;

  # Pad with 0's
  $yy = sprintf("%04d",$year);
  $mm = sprintf("%02d",$mon);
  $dd = sprintf("%02d",$mday);
  $hh = sprintf("%02d",$hour);
  $mi = sprintf("%02d",$min);
  $ss = sprintf("%02d",$sec);

  $date = "$yy/$mm/$dd-$hh:$mi:$ss";
  return $date;
}

#------------------------------------------------------------------------------
sub timeToNum
#------------------------------------------------------------------------------
{
  $zz_text = $_[0];
  $zz_text =~ s/-/\//g;
  $zz_text =~ s/:/\//g;
  ##print "zz_text=$zz_text\n";
  @words = split(/\//,$zz_text);

  if ($#words != 5)
  {
    &error("Input Target_End_Time ($zz_text) should be in the format: YYYY/MM/DD-HH:MM:SS","DOC116");
  }

  $zz_yyyy = $words[0];
  $zz_mon  = $words[1];
  $zz_dd   = $words[2];
  $zz_hh   = $words[3];
  $zz_mm   = $words[4];
  $zz_ss   = $words[5];
  ##print "zz_yyyy=$zz_yyyy zz_mon=$zz_mon zz_dd=$zz_dd zz_hh=$zz_hh zz_mm=$zz_mm zz_ss=$zz_ss\n";

  &error("Input Target_End_Time - YYYY must be 2002-2099","DOC116") if ($zz_yyyy < 2002 || $zz_yyyy > 2099);
  &error("Input Target_End_Time - MON  must be 1-12     ","DOC116") if ($zz_mon  <    1 || $zz_mon  >   12);
  &error("Input Target_End_Time - DD   must be 1-31     ","DOC116") if ($zz_dd   <    1 || $zz_dd   >   31);
  &error("Input Target_End_Time - HH   must be 0-23     ","DOC116") if ($zz_hh   <    0 || $zz_hh   >   23);
  &error("Input Target_End_Time - MM   must be 0-59     ","DOC116") if ($zz_mm   <    0 || $zz_mm   >   59);
  &error("Input Target_End_Time - SS   must be 0-59     ","DOC116") if ($zz_ss   <    0 || $zz_ss   >   59);

  @zz_date=($zz_ss,$zz_mm,$zz_hh,$zz_dd,--$zz_mon,$zz_yyyy);
  $zz_result = &timelocal(@zz_date);

  &error("Input Target_End_Time Must Be In The Future","DOC118") if ($zz_result < time);

  return $zz_result;
}

#-----------------------------------------------------------------------------
sub errorOld
#-----------------------------------------------------------------------------
{
   local($errorMsg,@error_fields) = @_;

   #print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body>";

   print "<h3> The following database error occured - $date<hr></h3>";
   print "</hr noshade>";
   print "<h4> $errorMsg $DBI::errstr</h4>";
   print "SQL statement: <pre>$statement $sql</pre>";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub displayErrorOld
#-----------------------------------------------------------------------------
{
   local($errorMsg,@error_fields) = @_;

   #print "Content-type: text/html\n\n";
   print "<head><title> Database Function Error - Output</title></head>";
   print "<body>";

   print "<h3> The following database error occured - $date<hr></h3>";
   print "</hr noshade>";
   print "<h4> $errorMsg</h4>";
   print "SQL statement: <pre>$statement</pre>";

   &PrintLinks;

   print "</body>";
   print "</html>";

   exit(1);
}

#-----------------------------------------------------------------------------
sub error_check
#-----------------------------------------------------------------------------
{
  if ($rqpairs{'user'} eq "")
  {
     push (@error_list, "Your Initials Must Not Be Blank\n");
  }

  if ($rqpairs{'reason'} eq "")
  {
     push (@error_list, "The Reason for Inhibiting Must Not Be Blank\n");
  }

  if (length($rqpairs{'user'}) != 2)
  {
     push (@error_list, "Your Initials Must Be 2 Characters In Length\n");
  }

  # Convert start and end dates into seconds
  $s_mm = $rqpairs{'s_mm'}-1;
  $e_mm = $rqpairs{'e_mm'}-1;
  @date=(0,0,$rqpairs{'s_hh'},$rqpairs{'s_dd'},$s_mm,$rqpairs{'s_yyyy'});
  $s_sec = &timelocal(@date);
  @date=(0,0,$rqpairs{'e_hh'},$rqpairs{'e_dd'},$e_mm,$rqpairs{'e_yyyy'});
  $e_sec = &timelocal(@date);
  if ($e_sec < $s_sec)
  {
     push (@error_list, "Inhibit Period End Timestamp Must Be Greater or Equal To Start Timestamp\n");
  }

  $inhibit_secs = $e_sec - $s_sec;
  $inhibit_days = int($inhibit_secs / (60*60*24));
  $max_days     = 60; 

  &msg("DEBUG Info: is=$inhibit_secs id=$inhibit_days");

  if ($inhibit_days > $max_days && $rqpairs{'reason'} !~ /PLEASE/)
  {
     push (@error_list, "Specified Inhibit Period Duration of $inhibit_days Days Is Too Long - Maximum: $max_days Days\n");
  }
}

#-----------------------------------------------------------------------------
sub IntHandler
#-----------------------------------------------------------------------------
{
  exit(0);
}

#-----------------------------------------------------------------------------
sub error_html 
#-----------------------------------------------------------------------------
{
   $manyerrors = @error_list;
   $str= "" ;
   $str1="";
   $str4="<h3>Insufficient or Missing Information:<hr></h3>";
   $html_str=$str.$str1.$str1.$str4;
   print "$html_str\n";
   print "<h4>Please correct the following:</h4>";
   print "<p>\n";
   print "<ul>\n";
   foreach( @error_list) 
   {
      print "<li> $_\n<br>";
   }
   print "</ul>\n";
   if ($manyerrors > 3) {
      print "$manyerrors errors - Having a bad day, are we?<p>\n";
   }
   else {
      print "$manyerrors correction(s) to make.<p>\n";
   }
   print "<hr>Click <b>BACK</b> and try again.\n";
      
}

#-----------------------------------------------------------------------------
sub create_form 
#-----------------------------------------------------------------------------
{
  ($sec,$min,$hour,$mday,$mon,$year)=localtime(time());
  $year += 1900;
  $mon++;

  print "
  <hr>
  $fs <b>Individual DBAmon Component Inhibit:</b>
    <li><a HREF='/cgi-bin/dbamon_ba_inhibit.pl?$in_title'><b>Backup Age Inhibit </b></a> - Turn off Backup Age Monitoring for $in_title
  <hr>
  "; 

  print "<FORM method='POST' action='/cgi-bin/dbamon_inhibit.pl'>";
  print "<b><font size=2>
             Instance: <font color=blue> $instance </font><br>
             Server: <font color=blue> $fqhostname </font></b>

    <font size=2><p>
    This transaction allows you to specify periods of time during
    which no DBAmon monitoring will occur. This can be 
    <br>useful for
    any future planned downtime. For more information, see
    <a href='http://dbamon.com/config/inhibit.shtml'><b>DBAmon Inhibit Reference</b></a>.
    To inhibit for one 
    <br>hour, make the start and end timestamp equal.
    <hr>
\n";

  ##print "<h2>year=$year mon=$mon mday=$mday hour=$hour </h2> ";
  print "<p> <form> 
  <table>
  <tr bgcolor=slate><th><th><h5>Year<th><h5>Month<th><h5>Day<th><h5>Hour</tr>\n";

  #
  # Process Start Date    
  #
  print "
  <tr>
  <td><B><font size=2>Inhibit Period Start Date-Hour:</b>
  <td><select name=s_yyyy>\n";
  for (2000..2020)
  {
    if ($_ == $year) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print "
  </select>
  <td><select name=s_mm>\n";
  for (01..12)
  {
    if ($_ == $mon) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print "
  </select>
  <td><select name=s_dd>\n";
  for (01..31)
  {
    if ($_ == $mday) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print "
  </select>
  <td><select name=s_hh>\n";
  for (00..23)
  {
    if ($_ == $hour) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print " </select>\n";

  #
  # Process End Date    
  #

  print "
  <tr>
  <td><B><font size=2>Inhibit Period End Date-Hour:</b>
  <td><select name=e_yyyy>\n";
  for (2000..2099)
  {
    if ($_ == $year) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print "
  </select>
  <td><select name=e_mm>\n";
  for (01..12)
  {
    if ($_ == $mon) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print "
  </select>
  <td><select name=e_dd>\n";
  for (01..31)
  {
    if ($_ == $mday) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print "
  </select>
  <td><select name=e_hh>\n";
  for (00..23)
  {
    if ($_ == $hour) 
    {
      print "<option selected>$_\n";
    } 
    else
    {
      print "<option>$_\n";
    } 
  }
  print " </select>\n";

  print "
  </table>

  <table>

  <tr><td><hr>
  <TR>
  <TH ALIGN=RIGHT><B><font size=2>Your Initials:<BR>
  </B><FONT SIZE=-1>(Example: BB)</FONT></TH>
  <TD>
  <INPUT type=text size=2 maxlength=2 name=user value=\"$user\"> <br>

  <tr><td><hr>
  <TR>
  <TH ALIGN=RIGHT><B><font size=2>Reason For Inhibiting:<BR>
  </B><FONT SIZE=-1>(Example: Scheduled Downtime)</FONT></TH>
  <TD>
  <INPUT type=text size=40 maxlength=40 name=reason value=\"$reason\"> <br>

  <tr><td><hr>

  <TR valign=top>
  <TH ALIGN=RIGHT><B><font size=2>Inhibit DBAmon for <br>This Instance or Entire Server?:<BR><FONT SIZE=-1></b>(Click One)</FONT> </B></TH>
  <TD valign=top><font size=2> 
    <INPUT name=inhtype type=radio value=instance CHECKED> <b>This-Instance </b> 
   <br>
    <INPUT name=inhtype type=radio value=server >          <b>Entire-Server</b> 
    </font>
    </td>
  <tr><td><hr>
  <TR>
  <TH ALIGN=RIGHT><B><font size=2>ACTION:<BR><FONT SIZE=-1></b>(Click One)</FONT> </B></TH>
  <TD>    <INPUT name=opcode type=radio value=insert           ><b><font size=2>Insert This Data</b>
      <br><INPUT name=opcode type=radio value=insertdel CHECKED><b><font size=2>Insert This Data After Deleting All Pre-Existing Inhibit Data</b>
      <br><INPUT name=opcode type=radio value=delete           ><b><font size=2>Delete All Inhibit Data</b>

  \n";

  print "</table> </b> <HR> <center>
  <b><INPUT type=submit value=\"Submit\"></input></b>
  <hr>
  <INPUT TYPE=HIDDEN NAME=instance value=\"$instance\">
  <INPUT TYPE=HIDDEN NAME=fqhostname value=\"$fqhostname\">
  </CENTER></form>
  <!--#include virtual=\"/solutions/dba/misc/foot.html\"-->
  ";
}

#-----------------------------------------------------------------------------
sub readHistory
#-----------------------------------------------------------------------------
{
  local($rh_type, $rh_data) = @_;
  # DI_INSTANCE                               NOT NULL CHAR(32)
  # DI_STR_C                                  NOT NULL CHAR(19)
  # DI_STR_N                                  NOT NULL NUMBER(38)
  # DI_END_C                                  NOT NULL CHAR(19)
  # DI_END_N                                  NOT NULL NUMBER(38)
  # DI_TS                                              DATE

  if ($rh_type eq "Instance")
  {
    $instance_colon = (split(/\_/,$rh_data))[0] . ":" . (split(/\_/,$rh_data))[1];
    $instance_colon .= "MSSQL" if $instance_colon =~ /\:$/;
    $rh_data = $instance_colon;
  }

  &connectDB();

  print "<p>"; 
  &msg("Creating Inhibit History Report for $rh_type $rh_data<p>");

  if ($dbamon_repos eq "O")
  {
    $sql = "select
      di_instance_or_server,
      di_str_c,
      di_str_n,
      di_end_c,
      di_end_n,
      to_char(di_ts,'YYYY/MM/DD-HH24:MI:SS'),
      di_reason,
      di_user
    from
      dbamon.inhibit
    where
      di_instance_or_server = '$rh_data'
    "; 
  }
  else
  {
    $sql = "select
      di_instance_or_server,
      di_str_c,
      di_str_n,
      di_end_c,
      di_end_n,
      --to_char(di_ts,'YYYY/MM/DD-HH24:MI:SS'),
      dbamon.dateconvert_19(di_ts),
      di_reason,
      di_user
    from
      dbamon.inhibit
    where
      di_instance_or_server = '$rh_data'
    "; 
  }

  ##&msg("DEBUG1 sql=$sql");

  $sth = $dbh->prepare($sql) || &error("DB_prepare");
  $sth->execute || &error("DB_execute");

  ##&msg("DEBUG2 sql=$sql");

  print "<table border=1 bgcolor=white>
    <tr bgcolor=slate>
    <th>$fs Instance<br> -or-<br> Server 
    <th>$fs Inhibit Period<br> Start<br> Timestamp <br>Character / Numeric
    <th>$fs Inhibit Period<br> End  <br> Timestamp <br>Character / Numeric
    <th>$fs Inhibit <br>Creation<br> Timestamp 
    <th>$fs Inhibit <br>Reason
    <th>$fs Inhibit <br>Created By User
  "; 
  
  $rowcount = 0;
  while (@Data = $sth->fetchrow_array)
  {
    $rowcount++; 

    $di_instance= shift @Data;
    $di_str_c   = shift @Data;
    $di_str_n   = shift @Data;
    $di_end_c   = shift @Data;
    $di_end_n   = shift @Data;
    $di_ts      = shift @Data;
    $di_reason  = shift @Data;
    $di_user    = shift @Data;

    print "<tr>
      <td><b>$fs $di_instance
      <td><b>$fs $di_str_c / $di_str_n
      <td><b>$fs $di_end_c / $di_end_n
      <td><b>$fs $di_ts
      <td><b>$fs $di_reason
      <td><b>$fs $di_user
    "; 
  }

  print "</table>"; 

  &msg("Selected $rowcount row(s)"); 
}

#-----------------------------------------------------------------------------
sub readData
#-----------------------------------------------------------------------------
{
  local($readfile,$readtype) = @_;

  $filename = $instance;
  system("rm -r /tmp/DBAmon/$readfile 2>/dev/null");

  if ($readfile && -e "/opt/dbamon/adm/inhibit/$readfile")
  {
    $cmd = "cp /opt/dbamon/adm/inhibit/$readfile /tmp/DBAmon 2>&1";
    &msg("Running cmd=$cmd");
    $rc = system($cmd);
  }
  else
  {
    &msg("(This is OK) - $readtype File does not exist"); 
  }

  system("id >>$SaveFile" );

  print "<br><font face=$font size=2>"; 
  if ($readtype eq "Instance")
  {
    $label = "<u><font color=darkred>INSTANCE-Level-Inhibit</font></u>"; 
  }
  else
  {
    $label = "<u><font color=darkred>SERVER-Level-Inhibit</font></u>"; 
  }

  print "<b>$label - Current Inhibit Data For This $readtype - Inhibit File: /opt/dbamon/adm/inhibit/$readfile</font></b>\n";

  if ($rc != 0) 
  {
    print "<font size=2><b>(Inhibit File: /opt/dbamon/adm/inhibit/$readfile Does Not Exist)</b>\n";
    return;
  }

  print "</font><pre><font size=2>";
  print "<b>=========== Start of File ==========\n<font color=blue></b>";

  if (! -e "/tmp/DBAmon/$readfile")  { &msg("(File not found - This is OK)"); }
  else
  {
    open(DATA, "/tmp/DBAmon/$readfile") || die "Can't open /tmp/DBAmon/$readfile - $!";
    while (<DATA>)
    {
      @words = split;
      $date = $words[0];
      #$time = $words[1];

      $row  = $_;
      chop $row;

      print "$row\n";
    }
    close(DATA);
  }

  print "</font><b>============ End of File ===========\n</b>";
  print "</pre><p>\n";
}

#-----------------------------------------------------------------------------
sub init_values 
#-----------------------------------------------------------------------------
{
  $dateraw = `date +%Y%m%d%H%M%S`;

  $yyyy = substr($dateraw,0,4);
  $mm   = substr($dateraw,4,2);
  $dd   = substr($dateraw,6,2);
  $hour = substr($dateraw,8,2);
  $min  = substr($dateraw,10,2);

  $s_yyyy = $yyyy;
  $s_mm   = $mm;
  $s_dd   = $dd;
  $s_hh   = $hour;
  $s_min  = $min;

  $e_yyyy = $yyyy;
  $e_mm   = $mm;
  $e_dd   = $dd;
  $e_hh   = 23;
  $e_min  = 59;

  $reason = "";
  $user   = "";
}

#-----------------------------------------------------------------------------
sub custom_html 
#-----------------------------------------------------------------------------
{
   print "<h1>Thank you for using this input form.</h1>";
   print "<h2>Your request has been sent.</h2>";
   print "<p><hr>\n";
}

#-----------------------------------------------------------------------------
sub CheckForEvilness
#-----------------------------------------------------------------------------
{
  #---- Attempt to make sure that no meta characters are entered in the form.
  local($woid2check) = @_;
  if (($woid2check =~ /\//) ||
      ($woid2check =~ /\;/) ||
      ($woid2check =~ /\</) ||
      ($woid2check =~ /\>/) ||
      ($woid2check =~ /\*/) ||
      ($woid2check =~ /\|/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\&/) ||
      ($woid2check =~ /\!/) ||
      ($woid2check =~ /\#/) ||
      ($woid2check =~ /\(/) ||
      ($woid2check =~ /\)/) ||
      ($woid2check =~ /\[/) ||
      ($woid2check =~ /\]/) ||
      ($woid2check =~ /\{/) ||
      ($woid2check =~ /\}/) ||
      ($woid2check =~ /\:/) ||
      ($woid2check =~ /\'/) ||
      ($woid2check =~ /\//) ||
      ($woid2check =~ /\n/) ||
      ($woid2check =~ /\"/))
        {
          print "Content-type: text/html\n\n";
          print "You have entered spurious control characters in a field.\n";
          print "You cannot use any of the following characters:\n";
          print " ;<>*|\'&!#()[]{}:\'/\"";
          print "\n The entry that is suspect is [$woid2check]\n";
          print "Please retry...\n";
          exit;
         }
}

#-----------------------------------------------------------------------------
sub deleteData
#-----------------------------------------------------------------------------
{
  $filename = $instance;
  $rc = system("cp /dev/null $outfile > $errfl 2>&1 ");
  if ($rc == 0)
  {
    print "<br>\n";
    &msg("All Inhibit Data Was Deleted From Inhibit File: $outfile (rc=$rc)");
  }
  else
  {
    $err = `cat $errfl`; 
    print "<h4>Error Deleting Data: $err</h4>\n";
  }
}

#-----------------------------------------------------------------------------
sub insertData
#-----------------------------------------------------------------------------
{
  $user     = $rqpairs{'user'};
  $instance = $rqpairs{'instance'};
  $reason   = $rqpairs{'reason'};
  chop($thedate = `date`);

  # Remove naughty characters
  $instance =~ s/'/"/g;

  $s_mm = $rqpairs{'s_mm'}-1;
  $e_mm = $rqpairs{'e_mm'}-1;

  # Convert start and end dates into seconds
  @date=(0,0,$rqpairs{'s_hh'},$rqpairs{'s_dd'},$s_mm,$rqpairs{'s_yyyy'});
  $s_sec = &timelocal(@date);
  @date=(59,59,$rqpairs{'e_hh'},$rqpairs{'e_dd'},$e_mm,$rqpairs{'e_yyyy'});
  $e_sec = &timelocal(@date);

  $s_text = &timeToText($s_sec); 
  $e_text = &timeToText($e_sec); 

  $instance_colon = (split(/\_/,$instance))[0] . ":" . (split(/\_/,$instance))[1];
  $instance_colon .= "MSSQL" if $instance_colon =~ /\:$/;
  &msg("DEBUG instance_colon=$instance_colon s_sec=$s_sec e_sec=$e_sec s_text=$s_text e_text=$e_text"); 

  if ($inhtype eq "server")
  {
    $insert_what = $fqhostname;
  }
  else
  {
    $insert_what = $instance_colon;
  }

  #DI_INSTANCE                               NOT NULL CHAR(32)
  #DI_STR_C                                  NOT NULL CHAR(19)
  #DI_STR_N                                  NOT NULL NUMBER(38)
  #DI_END_C                                  NOT NULL CHAR(19)
  #DI_END_N                                  NOT NULL NUMBER(38)
  #DI_TS                                              DATE
  # DI_REASON                                          VARCHAR2(80)
  # DI_USER                                            VARCHAR2(32)

  #---- Insert DB row
  $sql  = "insert into dbamon.inhibit (di_instance_or_server,di_str_c,di_str_n,di_end_c,di_end_n, di_reason, di_user) values ";
  $sql .= "(\'$insert_what', \'$s_text\', $s_sec, \'$e_text\', $e_sec, '$reason', '$user' )";
  &msg("DEBUG sql=$sql");
  $rc = $dbh->do($sql) || &error('insert_inhibit');

  $rc = open(OUT,">>$outfile");
  ##print "rc=$rc";
  if ($rc eq "")
  {
    print "<h4>Error writing to $outfile inhtype=$inhtype - $!</h4>\n";
    print "Solve this problem and retry transaction\n<hr>";
    exit 1;
  }

  $h_sec=3600;    # number of seconds in an hour

  for (;$s_sec <= $e_sec; $s_sec+=$h_sec) 
  {
    ($sec,$min,$hour,$mday,$mon,$year)=localtime($s_sec);
    printf OUT "Date=%d/%.2d/%.2d Hour=%.2d    # Established On %s By %s - $reason\n",
      (1900 + $year),$mon+1,$mday,$hour,$thedate,$user;
    $insertcount++;
  }
  close(OUT);
  &msg("Inserted $insertcount Inhibit Records Into File: $outfile");
}

#-----------------------------------------------------------------------------
sub reports
#-----------------------------------------------------------------------------
{
  print "
  <h3>Current Inhibit Data (If Any):</h3>
  <iframe src='/cgi-bin/dbamon_inhibit.pl?$instance?$fqhostname?reportfile' width=90% height=50%> </iframe>
  <p>
  <h3>Inhibit History:</h3>
  <iframe src='/cgi-bin/dbamon_inhibit.pl?$instance?$fqhostname?reporthist' width=90% height=70%> </iframe>
  "; 
}

#-----------------------------------------------------------------------------
#
# Main
#
#-----------------------------------------------------------------------------

#---- Prepare tmp dir 
system("mkdir /tmp/DBAmon 2>/dev/null"); 
system("chmod 777 /tmp/DBAmon 2>/dev/null"); 

($instance, $fqhostname, $in_title) = split(/\?/,$ARGV[0]);

$instance   =~ s/\\//g;
$fqhostname =~ s/\\//g;

&header("Inhibit Monitoring"); 
&msg("Starting - instance=$instance fqhostname=$fqhostname in_title=$in_title"); 

&connectDB;

$errfl = "/tmp/DBAmon/dbamon_inhibit.err";
$SaveFile = "/tmp/DBAmon/dbamon_inhibit.log";

#---- Create reports
if ($in_title eq "reportfile")
{
  print "<font size=2>";
  print "<body bgcolor=#E0E0E0>" ;
  &readData($instance,"Instance");
  &readData($fqhostname,"Server");
  exit;
}
if ($in_title eq "reporthist")
{
  print "<font size=2>";
  print "<body bgcolor=#E0E0E0>" ;
  &readHistory("Instance",$instance);
  &readHistory("Server",$fqhostname);
  exit;
}

#---- Get form data
&get_request;

#---- This will happen when they click SUBMIT from data-entry form
if ($instance eq "")
{
  $opcode     = $rqpairs{'opcode'};
  $inhtype    = $rqpairs{'inhtype'};
  $instance   = $rqpairs{'instance'};
  $fqhostname = $rqpairs{'fqhostname'};
  &msg("DEBUG Info: opcode=$opcode inhtype=$inhtype instance=$instance fqhostname=$fqhostname");

  if ($inhtype eq "server")
  {
    $outfile="/opt/dbamon/adm/inhibit/$fqhostname";
  }
  else
  {
    $outfile="/opt/dbamon/adm/inhibit/$instance";
  }

  if ($opcode eq "delete")
  {
    &deleteData;
  }

  if ($opcode eq "insertdel")
  {
    &error_check;
    if (@error_list != 0)
    {
      print LOG "Encountered errors\n";
      &error_html;
      exit 1;
    }
    print LOG "No errors\n";
    &deleteData;
    &insertData;
  }

  if ($opcode eq "insert")
  {
    &error_check;
    if (@error_list != 0)
    {
      print LOG "Encountered errors\n";
      &error_html;
      exit 1;
    }
    print LOG "No errors\n";
    &insertData;
  }

  &msg("Successful completion");

  print "<hr>\n";
  print "<script language='JavaScript'> function back() { history.go(-2); }</script>\n";
  print "<a href='javascript:back()'><b>Click Here</a></b> to return to the DBAmon Instance Summary.";


  close(LOG);
  exit 0;
}

#---- If we got here, then it is the first invocation

if (! $fqhostname)
{
  print "<b><font color=red>
  ERROR: The fully qualified host name from this instance is not known.
  This can occur if 'nslookup' on this hostname does not return anything
  (name server down.)
  </b></font>\n";
}

#---- Init date values
if ($ts eq "")
{
  &init_values;
}

#---- Print finished form
&create_form;

#---- Reports - current inh data and inhibit history 
&reports;

#---- Terminate
print "</b></b><hr>"; 
&msg("Done"); 
close(LOG);
exit 0;
